# Shell  |  Copyright(C), 2004-5, Enfold Systems, LLC
#
# Enfold Systems, LLC
# 4617 Montrose Blvd., Suite C215
# Houston, Texas 77006 USA
# p. +1 713.942.2377 | f. +1 832.201.8856
# www.enfoldsystems.com
# info@enfoldsystems.com
#
#
# This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.

from tempfile import mktemp

class instance:
    def __init__(self, app, frame):
        self.app = app
        self.frame= frame

    def log(self):
        """ Makes a log of this session to a temp file """
        file = mktemp('.txt')
        text = self.frame.frame.shell.GetText()
        open(file, 'wb').write(text)
        self.frame.frame.shell.write("Log of this session written to %s" % file)

    def sync(self):
        """ Sync the changes made by this client with the server """
        self.app._p_jar.sync()

    def commit(self):
        """ Sync and then commit the changes to this app. """
        self.sync()
        get_transaction().commit()

    def _runcmds(self, cmds):
        for cmd in cmds:
            self.frame.frame.shell.run(cmd)

    def pm(self, url, **kw):
        """ Runs the url through Zope.debug and
        then drops you into the python debugger at
        the point the error occured using post mortem debugging """
        if not kw.has_key('pm'):
            kw['pm'] = 1
        s = ''
        for k, v in kw.items():
            if type(v) == type(''):
                s += ', %s="%s"' % (k, str(v))
            else:
                s += ', %s=%s' % (k, v)
        cmds = [
            "import Zope; Zope.debug('%s'%s)" % (url, s),
            "import pdb; pdb.pm()",
            ]
        self._runcmds(cmds)
