# Shell  |  Copyright(C), 2004-5, Enfold Systems, LLC
#
# Enfold Systems, LLC
# 4617 Montrose Blvd., Suite C215
# Houston, Texas 77006 USA
# p. +1 713.942.2377 | f. +1 832.201.8856
# www.enfoldsystems.com
# info@enfoldsystems.com
#
#
# This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.

import sys
import os

# pyshell magic
import __main__
original = __main__.__dict__.keys()

from wx.py.PyShell import App as PyApp
from wx.py.shell import Shell
from wx.py.shell import ShellFrame
from wx.py import frame
import wx

import admin
from enShellBase import callback

class App(PyApp):
    """PyShell standalone application."""

    def OnInit(self):
        # wierd wx bootstrapping
        # requires imports need to be defined here
        # need to read up for more info
        import wx
        import os
        from wx import py
        from wxPython.wx import wxIcon, wxBITMAP_TYPE_ICO

        locals = __main__.__dict__
        wx.InitAllImageHandlers()

        from enShellBase import MyFrame
        self.frame = MyFrame(locals=locals)

        self.frame.SetSize((750, 525))
        self.frame.Show()
        self.SetTopWindow(self.frame)
        self.frame.shell.SetFocus()

        return True

def main(callback):
    """The main function for the PyShell program.

    Callback added
    """
    # Cleanup the main namespace, leaving the App class.
    import __main__
    md = __main__.__dict__
    keepers = original
    keepers.append('App')
    for key in md.keys():
        if key not in keepers:
            del md[key]
    # Create an application instance.
    app = App(0)
    # Cleanup the main namespace some more.
    if md.has_key('App') and md['App'] is App:
        del md['App']
    if md.has_key('__main__') and md['__main__'] is __main__:
        del md['__main__']
    # Mimic the contents of the standard Python shell's sys.path.
    import sys
    if sys.path[0]:
        sys.path[0] = ''
    # Add the application object to the sys module's namespace.
    # This allows a shell user to do:
    # >>> import sys
    # >>> sys.app.whatever
    sys.app = app
    del sys
    # Start the wxPython event loop.

    # run the go get Zeo callback...
    zapp = callback()

    import __builtin__
    __builtin__.app = zapp

    # import plone site, to make the ui snappier
    pl = getattr(zapp, "Plone", None)
    if pl:
        # this should trigger all the imports
        dir(zapp.Plone)

    # add in the admin module
    __builtin__.admin = admin.instance(zapp, app)
    app.MainLoop()


if __name__ == '__main__':
    if len(sys.argv) < 2:
        print "Usage: pyshell ZOPE_CLIENT"

    c = callback(sys.argv[1])
    main(c)
